<?php

/*
Plugin Name: WP All Import - WP Residence Add-On
Plugin URI: http://www.wpallimport.com/
Description: Supporting imports into the WP Residence theme.
Version: 1.2.2
Author: Soflyy
*/


include "rapid-addon.php";

include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

$wpresidence_addon = new RapidAddon( 'WP Residence Add-On', 'realhomes_addon' );

$custom_type = wpresidence_addon_get_post_type();

// Agents Post Type 		= estate_agent
// Properties Post Type 	= estate_property

switch( $custom_type ) {

	case "estate_agent":
		
		$wpresidence_addon->add_field( 'agent_position', 'Position', 'text' );

		$wpresidence_addon->add_field( 'agent_email', 'Email', 'text' );

		$wpresidence_addon->add_field( 'agent_phone', 'Phone', 'text' );

		$wpresidence_addon->add_field( 'agent_mobile', 'Mobile', 'text' );

		$wpresidence_addon->add_field( 'agent_skype', 'Skype', 'text' );

		$wpresidence_addon->add_field( 'agent_facebook', 'Facebook', 'text' );

		$wpresidence_addon->add_field( 'agent_twitter', 'Twitter', 'text' );

		$wpresidence_addon->add_field( 'agent_linkedin', 'LinkedIn', 'text' );

		$wpresidence_addon->add_field( 'agent_pinterest', 'Pinterest', 'text' );

		$wpresidence_addon->add_field( 'agent_instagram', 'Instagram', 'text' );

		$wpresidence_addon->add_field( 'agent_website', 'Website (without http)', 'text' );

		$wpresidence_addon->add_options( null, 'Appearance Options', array(

			$wpresidence_addon->add_field( 'header_type', 'Header Type', 'radio', 	
				array(
					'0' => 'Global',
					'1' => 'None',
					'2' => array(
						'Image',
						$wpresidence_addon->add_field( 'page_custom_image', 'Header Image', 'image' )
					),
					'3' => 'Theme Slider',
					'4' => array(
						'Revolution Slider',
						$wpresidence_addon->add_field( 'rev_slider', 'Revolution Slider Name', 'text' ),
					),
					'5' => array(
						'Google Map',
						$wpresidence_addon->add_field( 'page_custom_lat', 'Map - Center point Latitude', 'text' ),
						$wpresidence_addon->add_field( 'page_custom_long', 'Map - Center point Longitude', 'text' ),
						$wpresidence_addon->add_field( 'page_custom_zoom', 'Zoom Level for map (1-20)', 'text' ),
						$wpresidence_addon->add_field( 'min_height', 'Height of the map when closed', 'text', null, 'In pixels, example: 200' ),
						$wpresidence_addon->add_field( 'max_height', 'Height of map when open', 'text', null, 'In pixels, example: 600' ),
						$wpresidence_addon->add_field( 'keep_min', 'Force the map closed', 'radio', array(
							'no' => 'No',
							'yes' => 'Yes'	
						) )
			) ) ),

			$wpresidence_addon->add_field( 'header_transparent', 'Use transparent header', 'radio', 
			array(
				'global' => 'Global',
				'no' => 'No',
				'yes' => 'Yes'
			) ),

						$wpresidence_addon->add_field( 'sidebar_option', 'Where to Show the Sidebar', 'radio', 
			array(
				'right' => 'Right',
				'left' => 'Left',
				'none' => 'None'
			) ),

			$wpresidence_addon->add_field( 'sidebar_select', 'Select the Sidebar', 'radio', 
			array(
				'primary-widget-area' => 'Primary Widget Area',
				'secondary-widget-area' => 'Secondary Widget Area',
				'first-footer-widget-area' => 'First Footer Widget Area',
				'second-footer-widget-area' => 'Second Footer Widget Area',
				'third-footer-widget-area' => 'Third Footer Widget Area',
				'fourth-footer-widget-area' => 'Fourth Footer Widget Area',
				'top-bar-left-widget-area' => 'Top Bar Left Widget Area',
				'top-bar-right-widget-area' => 'Top Bar Right Widget Area'
			) ),

			$wpresidence_addon->add_field( 'slide_template', 'RevSlider Slide Template', 'text', null, 'Meta ID of the desired slide template' ) ) 
		);

		$wpresidence_addon->set_import_function( 'wpresidence_addon_import' );

		$wpresidence_addon->admin_notice();

		$wpresidence_addon->run(
			array(
				"post_types" => array( "estate_agent" )
			)
		);

		function wpresidence_addon_import( $post_id, $data, $import_options, $article ) {

			global $wpresidence_addon;

			$fields = array(
				'agent_position',
				'agent_email',
				'agent_phone',
				'agent_mobile',
				'agent_skype',
				'agent_facebook',
				'agent_twitter',
				'agent_linkedin',
				'agent_pinterest',
				'agent_instagram',
				'agent_website',
				'header_type',
				'header_transparent',
				'rev_slider',
				'min_height',
				'max_height',
				'keep_min',
				'sidebar_agent_option',
				'local_pgpr_slider_type',
				'local_pgpr_content_type',
				'sidebar_option',
				'sidebar_select',
				'slide_template',
				'page_custom_lat',
				'page_custom_long'
				);

			foreach ( $fields as $field ) {

		        if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

		        	update_post_meta( $post_id, $field, $data[ $field ] );


		        }

		    }

		    $fields = array(
		    	'page_custom_image'
		    	);

		    foreach ( $fields as $field ) {

	            if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_image( $import_options ) ) {

	                $id = $data[ $field ]['attachment_id'];

	                $url = wp_get_attachment_url( $id );

	                update_post_meta( $post_id, $field, $url );

	            }

	        }

	        // set map zoom
		    $field = 'page_custom_zoom';

		    if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

		    	$zoom = ( empty( $data[$field] ) ? 15 : $data[$field] );

		        update_post_meta( $post_id, $field, $zoom );

		    }

		}

		break;

	case "estate_property":

		$wpresidence_addon->disable_default_images();

		$wpresidence_addon->import_images( 'property_images', 'Property Images' );

		$wpresidence_addon->add_field( 'property_price', 'Price', 'text', null, 'Only digits, example: 435000' );

		$wpresidence_addon->add_field( 'property_label_before', 'Before Price Label', 'text', null, 'Example: Per Month' );

		$wpresidence_addon->add_field( 'property_label', 'After Price Label', 'text', null, 'Example: Per Month' );

		$wpresidence_addon->add_field( 'property_size', 'Size', 'text' );

		$wpresidence_addon->add_field( 'property_lot_size', 'Lot Size', 'text' );

		$wpresidence_addon->add_field( 'property_rooms', 'Rooms', 'text' );

		$wpresidence_addon->add_field( 'property_bedrooms', 'Bedrooms', 'text' );

		$wpresidence_addon->add_field( 'property_bathrooms', 'Bathrooms', 'text' );
        
        $wpresidence_addon->add_field('energy_index', 'Energy Index in kWh/m2a', 'text');
        
        $wpresidence_addon->add_field('energy_class', 'Energy Class', 'radio', array(
        'A+' => 'A+',
        'A' => 'A',
        'B' => 'B',
        'C' => 'C',
        'D' => 'D',
        'E' => 'E',
        'F' => 'F',
        'G' => 'G'
        ));

		$wpresidence_addon->add_field( 'property_features', 'Features and Amenities', 'text', null, 'Comma delimited list of features and amenities' );

		$wpresidence_addon->add_title( 'Property Subunits' );

		$wpresidence_addon->add_field( 'enable_subunits', 'Enable Subunits?', 'radio', array(
			'no' => 'No',
			'yes' => array(
				'Yes',
				$wpresidence_addon->add_field( 'property_subunits_list', 'Subunit IDs', 'text', null, 'Comma delimited list of subunit IDs' )
				)
			)
		);

		$wpresidence_addon->add_title( 'Custom Property Details' );

		$wpresidence_addon->add_text( 'To edit existing and add new custom property details go to Appearance > WP Residence Options > Listings Customs Fields. Make sure that the imported values conform to the requirements of the selected field type designated on the WP Residence options page.' );

		// New option that contains custom fields in WP Residence 1.50.1 +
		$custom_details = get_option( 'wpestate_custom_fields_list' );

		$custom_details = ( empty( $custom_details ) ? array() : $custom_details );

		if ( ! empty( $custom_details ) ) {

			$custom_details = maybe_unserialize( $custom_details );

			if ( array_key_exists( 'add_field_name', $custom_details ) ) {

				foreach ( $custom_details['add_field_name'] as $cd_key => $cd ) {

					$key = str_replace( ' ', '-', $cd );

					$label = ( array_key_exists( $cd_key, $custom_details['add_field_label'] ) ? $custom_details['add_field_label'][ $cd_key ] : $cd );

					$wpresidence_addon->add_field( '_custom_details_' . $key, $label, 'text' );

				}

			}

		} else {
			// get all the custom details
			$custom_details = get_option( 'wp_estate_custom_fields' );

			$custom_details = ( empty( $custom_details ) ? array() : $custom_details );

			if ( !empty( $custom_details ) ) {
				// build the key array for the UI and the field array for the actual import
				foreach ($custom_details as $custom_detail) {

					$key = $custom_detail[0];

					$key = str_replace( ' ', '-', $key );

					$label = $custom_detail[1] . ' (' . $custom_detail[2] . ')';

					$wpresidence_addon->add_field( '_custom_details_' . $key, $label, 'text' );

				}
			}
			//
		} 
		$wpresidence_addon->add_title( 'Property Video' );

		$wpresidence_addon->add_field( 'embed_video_type', 'Video from:', 'radio', 
			array(
				'youtube' => 'YouTube',
				'vimeo' => 'Vimeo'
		) );

		$wpresidence_addon->add_field( 'embed_video_id', 'Embed Video ID', 'text', null, 'Embed ID from http://www.youtube.com/watch?v=dQw4w9WgXcQ would be: dQw4w9WgXcQ' );

		$wpresidence_addon->add_title( 'Property Location' );

		$wpresidence_addon->add_field( 'property_address', 'Address', 'text', null, 'Building number and street name, example: 1206 King St' );

		$wpresidence_addon->add_field( 'property_zip', 'Zip', 'text' );

		$wpresidence_addon->add_field( 'property_country', 'Country', 'text' );

		$wpresidence_addon->add_field(
			'location_settings',
			'Map Location',
			'radio', 
			array(
				'search_by_address' => array(
					'Search by Address',
					$wpresidence_addon->add_options( 
						$wpresidence_addon->add_field(
							'_property_location_search',
							'Property Address',
							'text'
						),
						'Google Geocode API Settings', 
						array(
							$wpresidence_addon->add_field(
								'address_geocode',
								'Request Method',
								'radio',
								array(
									'address_no_key' => array(
										'No API Key',
										'Limited number of requests.'
									),
									'address_google_developers' => array(
										'Google Developers API Key - <a href="https://developers.google.com/maps/documentation/geocoding/#api_key">Get free API key</a>',
										$wpresidence_addon->add_field(
											'address_google_developers_api_key', 
											'API Key', 
											'text'
										),
										'Up to 2,500 requests per day and 5 requests per second.'
									),
									'address_google_for_work' => array(
										'Google for Work Client ID & Digital Signature - <a href="https://developers.google.com/maps/documentation/business">Sign up for Google for Work</a>',
										$wpresidence_addon->add_field(
											'address_google_for_work_client_id', 
											'Google for Work Client ID', 
											'text'
										), 
										$wpresidence_addon->add_field(
											'address_google_for_work_digital_signature', 
											'Google for Work Digital Signature', 
											'text'
										),
										'Up to 100,000 requests per day and 10 requests per second'
									)
								) // end Request Method options array
							) // end Request Method nested radio field 
						) // end Google Geocode API Settings fields
					) // end Google Gecode API Settings options panel
				), // end Search by Address radio field
				'search_by_coordinates' => array(
					'Enter Coordinates',
					$wpresidence_addon->add_field(
						'_property_latitude', 
						'Latitude', 
						'text', 
						null, 
						'Example: 34.0194543'
					),
					$wpresidence_addon->add_field(
						'_property_longitude',
						'Longitude',
						'text',
						null, 
						'Example: -118.4911912'
					) // end coordinates Option panel
				) // end Search by Coordinates radio field
			) // end Property Location radio field
		);

		$wpresidence_addon->add_options( null, 'Advanced Options', array(

			$wpresidence_addon->add_field( 'property_agent', 'Agent Responsible', 'text', null, 'Match by Agent name. If no match found, a new Agent will be created.' ),

			$wpresidence_addon->add_field( 'property_user', 'Assign Property to User', 'text', null, 'Match by user ID, email, login, or slug' ),

			$wpresidence_addon->add_field( 'property_google_view', 'Enable Google Street View', 'radio', array(
				'1' => 'Yes',
				'' => 'No'
			) ),

			$wpresidence_addon->add_field( 'google_camera_angle', 'Google Street View Camera Angle', 'text'),

			$wpresidence_addon->add_field( 'page_custom_zoom', 'Zoom Level for map (1-20)', 'text'),

			$wpresidence_addon->add_field( 'property_status', 'Property Status', 'text' ),

			$wpresidence_addon->add_field( 'prop_featured', 'Featured Property', 'radio',
				array(
					'0' => 'No',
					'1' => 'Yes'
			) ),

			$wpresidence_addon->add_field( 'property_theme_slider', 'Property in theme Slider', 'radio',
				array(
					'0' => 'No',
					'1' => 'Yes'
			) ),

			$wpresidence_addon->add_field( 'owner_notes', 'Owner/Agent Notes', 'text', null, 'Not visible on the front end' ),

			$wpresidence_addon->add_field( 'post_show_title', 'Show Title', 'radio',
				array(
					'yes' => 'Yes',
					'no' => 'No'
				) ),

			$wpresidence_addon->add_field( 'property_page_desing_local', 'Use a custom property page template', 'text', null, 'Must be template title, slug, or ID' ),


			$wpresidence_addon->add_field( 'header_type', 'Header Type', 'radio', 	
				array(
					'0' => 'Global',
					'1' => 'None',
					'2' => array(
						'Image',
						$wpresidence_addon->add_field( 'page_custom_image', 'Header Image', 'image' )
					),
					'3' => 'Theme Slider',
					'4' => array(
						'Revolution Slider',
						$wpresidence_addon->add_field( 'rev_slider', 'Revolution Slider Name', 'text' ),
					),
					'5' => array(
						'Google Map',
						$wpresidence_addon->add_field( 'min_height', 'Map height when closed', 'text', null, 'In pixels, example: 200' ),
						$wpresidence_addon->add_field( 'max_height', 'Map height when open', 'text', null, 'In pixels, example: 600' ),
						$wpresidence_addon->add_field( 'keep_min', 'Force the map closed', 'radio', array(
							'no' => 'No',
							'yes' => 'Yes'	
						) )
			) ) ),

			$wpresidence_addon->add_field( 'header_transparent', 'Use transparent header?', 'radio', 
			array(
				'global' => 'Global',
				'no' => 'No',
				'yes' => 'Yes'
			) ),

			$wpresidence_addon->add_field( 'sidebar_agent_option', 'Show Agent in Sidebar', 'radio', 
			array(
				'global' => 'Global',
				'no' => 'No',
				'yes' => 'Yes'
			) ),

			$wpresidence_addon->add_field( 'local_pgpr_slider_type', 'Slider Type', 'radio', 
			array(
				'global' => 'Global',
				'vertical' => 'Vertical',
				'horizontal' => 'Horizontal'
			) ),

			$wpresidence_addon->add_field( 'local_pgpr_content_type', 'Show Content As', 'radio', 
			array(
				'global' => 'Global',
				'accordion' => 'Accordion',
				'tabs' => 'Tabs'
			) ),

			$wpresidence_addon->add_field( 'sidebar_option', 'Where to Show the Sidebar', 'radio', 
			array(
				'right' => 'Right',
				'left' => 'Left',
				'none' => 'None'
			) ),

			$wpresidence_addon->add_field( 'sidebar_select', 'Select the Sidebar', 'radio', 
			array(
				'primary-widget-area' => 'Primary Widget Area',
				'secondary-widget-area' => 'Secondary Widget Area',
				'first-footer-widget-area' => 'First Footer Widget Area',
				'second-footer-widget-area' => 'Second Footer Widget Area',
				'third-footer-widget-area' => 'Third Footer Widget Area',
				'fourth-footer-widget-area' => 'Fourth Footer Widget Area',
				'top-bar-left-widget-area' => 'Top Bar Left Widget Area',
				'top-bar-right-widget-area' => 'Top Bar Right Widget Area'
			) ),

			$wpresidence_addon->add_field( 'slide_template', 'RevSlider Slide Template', 'text', null, 'Meta ID of the desired slide template' )

		) );

		$wpresidence_addon->set_import_function( 'wpresidence_addon_import' );

		$wpresidence_addon->admin_notice();

		$wpresidence_addon->run(
			array(
				"post_types" => array( "estate_property" )
			)
		);

		function wpresidence_addon_import( $post_id, $data, $import_options, $article ) {
		    
		    global $wpresidence_addon;

		    // all fields except for slider and image fields
		    $fields = array(
				'property_price',
				'property_label_before',
				'property_label',
				'property_size',
				'property_lot_size',
				'property_rooms',
				'property_bedrooms',
				'property_bathrooms',
				'embed_video_type',
				'embed_video_id',
				'property_address',
				'property_zip',
				'property_country',
				'property_google_view',
				'google_camera_angle',
				'prop_featured',
				'owner_notes',
				'header_type',
				'header_transparent',
				'rev_slider',
				'min_height',
				'max_height',
				'keep_min',
				'sidebar_agent_option',
				'local_pgpr_slider_type',
				'local_pgpr_content_type',
				'sidebar_option',
				'sidebar_select',
				'slide_template',
				'post_show_title',
				'hidden_address',
                'energy_index',
                'energy_class'
		    );
		    
		    // image fields
		    $image_fields = array(
		        'page_custom_image' 
			);

			// an array for custom detail field postmeta keys
			$custom_details_fields = array();
			
			$custom_details = get_option( 'wpestate_custom_fields_list' );

			if ( ! empty( $custom_details ) ) {

				$custom_details = maybe_unserialize( $custom_details );

				if ( array_key_exists( 'add_field_name', $custom_details ) ) {

					foreach ( $custom_details['add_field_name'] as $cd_key => $cd ) {
	
						$key = $cd;

						$key = str_replace( ' ', '-', $key );		
					
						$custom_details_fields[] = '_custom_details_' . $key;
	
					}
	
				}

			} else {

				// get all the custom details
				$custom_details = get_option( 'wp_estate_custom_fields' );

				// build the key array for the UI and the field array for the actual import
				if ( !empty( $custom_details ) ) {

					foreach ($custom_details as $custom_detail) {

						$key = $custom_detail[0];

						$key = str_replace( ' ', '-', $key );		
					
						$custom_details_fields[] = '_custom_details_' . $key;

					}
				}
			}
		    
		    $fields = array_merge( $fields, $custom_details_fields, $image_fields );

		    // update everything in fields arrays
		    foreach ( $fields as $field ) {

		        if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

		            if ( in_array( $field, $image_fields ) ) {

		                if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_image( $import_options ) ) {

		                    $id = $data[$field]['attachment_id'];

		                    $url = wp_get_attachment_url( $id );

		                    update_post_meta( $post_id, $field, $url );

		                }

		            } elseif ( in_array( $field, $custom_details_fields ) ) {

		            	$key = substr( $field, 16 );

		            	if ( function_exists( 'wpestate_limit45' ) ) $key = wpestate_limit45( sanitize_title( $key ) );
		        		$key = strtolower( sanitize_key( $key ) );
                        if ( empty( $article['ID'] ) || $wpresidence_addon->can_update_meta( $key, $import_options ) ) {
                            update_post_meta( $post_id, $key, $data[ $field ] );
                        }

		            } elseif ( $field == 'hidden_address' ) {
						
						/*
						 *  Create a temporary custom field to indicate
						 *   that the 'hidden_address' field is to be updated
						 */
		                update_post_meta( $post_id, 'temp_is_update_hidden_address', 'yes' );

		            } else {

		                update_post_meta( $post_id, $field, $data[$field] );

		            }
		        }
		    }

		    // set map zoom
		    $field = 'page_custom_zoom';

		    if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

		    	$zoom = ( empty( $data[$field] ) ? 15 : $data[$field] );

		        update_post_meta( $post_id, $field, $zoom );

		    }

		    // clear image fields to override import settings
		    $fields = array(
		    	'page_custom_image'
		    );

		    if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_image( $import_options ) ) {

		    	foreach ($fields as $field) {

			    	delete_post_meta($post_id, $field);

			    }

		    }

		    // do not support floor plans
		    $field = 'use_floor_plans';

		    if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

		        update_post_meta( $post_id, $field, 0 );

		    }

		    // add empty features
		    $fields = explode(',',get_option( 'wp_estate_feature_list' ));
		    
		    $features = array();

		    foreach ($fields as $field) {

		    	if ( !empty( $field ) ) {
			    
			    	$field = trim($field);

			    	$features[] = $field;

			    	$field = sanitize_key(str_replace(' ', '_', $field));

			    	if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

			            update_post_meta( $post_id, $field, '' );

			        }
			    }
		    }

		    // add imported features
			$fields = explode(',', $data['property_features']);

		    $wpresidence_addon->log( 'Updating Features and Amenities' );

		    foreach ($fields as $field) {

		    	$field = trim($field);

		    	$field_ = sanitize_key(str_replace(' ', '_', $field));

		    	if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field_, $import_options ) ) {

		            update_post_meta( $post_id, $field_, 1 );

		            // add new features to features list
		            if ( !in_array( $field, $features ) ) {

					    $wpresidence_addon->log( '- <b>WARNING:</b> Existing feature "' . $field . '" not found, adding to database and assigning to property' );

		            	$features[] = $field;

		            }
		        }
		    }

		    // replace wp_estate_feature_list option with features list
		    $features = implode(', ', $features);

		    update_option( 'wp_estate_feature_list', $features );

		    // update property status
		    $field = 'property_status';

			if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

			    $wpresidence_addon->log( 'Updating Property Status' );

			    $statuses = explode( ',', get_option( 'wp_estate_status_list' ) );

			    $trimmed_statuses = array();

			    if ( !empty( $statuses ) ) {

				    foreach ( $statuses as $status ) {

				    	$status = trim($status);

				    	$trimmed_statuses[] = $status;

				    }

				}

			    $statuses = $trimmed_statuses;

			    if ( in_array( $data[$field], $statuses ) ) {

				    $wpresidence_addon->log( '- Existing property status found, setting property status to "' . $data[$field] . '"' );

		        update_post_meta( $post_id, $field, $data[$field] );

			    } else {

				    $wpresidence_addon->log( '- <b>WARNING:</b> Existing property status not found, adding new status "' . $data[$field] . '" and assigning to property' );

		        update_post_meta( $post_id, $field, $data[$field] );

		        $statuses[] = $data[$field];

		        $statuses = implode( ', ', $statuses );

				    update_option( 'wp_estate_status_list', $statuses );

			    }

			}

			// update agent, create a new one if not found
			$field = 'property_agent';
			$post_type = 'estate_agent';

			if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {
				$wpresidence_addon->log( 'Assign Property to Responsible Agent' );
				
				if ( empty( $data[ $field ] ) ) {
					$wpresidence_addon->log( ' - <b>WARNING:</b> Agent field is empty in import. No agent will be assigned.' );
					update_post_meta( $post_id, $field, null );
				} else {

					$post = get_page_by_title( $data[$field], 'OBJECT', $post_type );

					if ( !empty( $post ) ) {

					$wpresidence_addon->log( '- Existing agent found. ' . $data[$field] . ' is now responsible for this property.' );

						update_post_meta( $post_id, $field, $post->ID );

					} else {

						// insert title and attach to property
						$postarr = array(
						'post_content'   => '',
						'post_name'      => $data[$field],
						'post_title'     => $data[$field],
						'post_type'      => $post_type,
						'post_status'    => 'publish',
						'post_excerpt'   => ''
						);

						wp_insert_post( $postarr );

						$post = get_page_by_title( $data[$field], 'OBJECT', $post_type );

					$wpresidence_addon->log( '- <b>WARNING:</b> Existing agent not found. Agent ' . $data[$field] . ' added and is now responsible for this property.' );

						update_post_meta( $post_id, $field, $post->ID );

					}
				}
			}

			// find and assign custom page template
			$field = 'property_page_desing_local';

			if ( empty( $article['ID'] ) || $wpresidence_addon->can_update_meta( $field, $import_options ) ) {
					global $wpdb;

					if ( empty( $data[ $field ] ) ) {
						update_post_meta( $post_id, $field, '' );
					} elseif ( $found_posts = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM " . $wpdb->posts . " WHERE `post_title` = '%s' AND `post_type` = 'page' LIMIT 1;", $data[ $field ] ) ) ) {
						if ( get_post_meta( $found_posts->ID, '_wp_page_template', true ) == 'page_property_design.php' ) {
							update_post_meta( $post_id, $field, $found_posts->ID );
						}
					} elseif ( $found_posts = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM " . $wpdb->posts . " WHERE `post_name` = '%s' AND `post_type` = 'page' LIMIT 1;", $data[ $field ] ) ) ) {
							if ( get_post_meta( $found_posts->ID, '_wp_page_template', true ) == 'page_property_design.php' ) {
								update_post_meta( $post_id, $field, $found_posts->ID );
							}
					} elseif( $found_posts = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM " . $wpdb->posts . " WHERE `ID` = '%s' AND `post_type` = 'page' LIMIT 1;", $data[ $field ] ) ) ) {
							if ( get_post_meta( $found_posts->ID, '_wp_page_template', true ) == 'page_property_design.php' ) {
								update_post_meta( $post_id, $field, $found_posts->ID );
							}
					} else {
							update_post_meta( $post_id, $field, '' );
					}

			}

			// Take care of property subunits
			$field = 'enable_subunits';

			if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

				if ( $data[ $field ] == 'yes' && !empty( $data[ 'property_subunits_list'] ) ) {

					if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( 'property_subunits_list', $import_options ) ) {

						update_post_meta( $post_id, 'property_subunits_list', explode( ",", $data['property_subunits_list'] ) );

					}

					if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( 'property_subunits_list_manual', $import_options ) ) {

						update_post_meta( $post_id, 'property_subunits_list_manual', $data['property_subunits_list'] );

					}

					if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( 'property_has_subunits', $import_options ) ) {

						update_post_meta( $post_id, 'property_has_subunits', '1' );

					}

				} elseif ( $data[ $field ] == 'no' ) {

					if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( 'property_has_subunits', $import_options ) ) {

						update_post_meta( $post_id, 'property_has_subunits', '' );

					}

					if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( 'property_subunits_list_manual', $import_options ) ) {

						update_post_meta( $post_id, 'property_subunits_list_manual', '' );

					}

				}

			}



			// assign property to user
		    $field = 'property_user';

			$wpresidence_addon->log( 'Assign Property to User' );

			if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

				$user = get_user_by( 'id', $data[$field] );

				if ( $user === false ) {

					$user = get_user_by( 'slug', $data[$field] );

				}

				if ( $user === false ) {

					$user = get_user_by( 'email', $data[$field] );

				}

				if ( $user === false ) {

					$user = get_user_by( 'login', $data[$field] );

				}

				if ( $user != false ) {

					$id = $user->ID;

				    $wpresidence_addon->log( '- User found, assigning property to ' . $user->data->user_nicename );

		            update_post_meta( $post_id, $field, $id );

				} else {

					$users = get_super_admins();

					$user = get_user_by( 'login', $users[0] );

					$id = $user->ID;

			    $wpresidence_addon->log( '- <b>WARNING:</b> No user found searching for "'. $data[$field] . '", assigning property to ' . $user->data->user_nicename );

		      update_post_meta( $post_id, $field, $id );

				}

		        // change author to property_user
		        // in this case $id refers to the property_user $id from above
		        $current_id = wpsestate_get_author( $post_id );
		        
		        if( $current_id != $id ){

		            $post = array(
		                'ID'            => $post_id,
		                'post_author'   => $id
		            );

		            wp_update_post( $post ); 
		        }

			}



		    // update property location
		    $wpresidence_addon->log( 'Updating Map Location' );

		    $field   = '_property_location_search';

		    $address = $data[$field];

		    $lat  = $data['_property_latitude'];

		    $long = $data['_property_longitude'];
		    
		    //  build search query
		    if ( $data['location_settings'] == 'search_by_address' ) {

		    	$search = ( !empty( $address ) ? 'address=' . rawurlencode( $address ) : null );

		    } else {

		    	$search = ( !empty( $lat ) && !empty( $long ) ? 'latlng=' . rawurlencode( $lat . ',' . $long ) : null );

		    }

		    // build api key
		    if ( $data['location_settings'] == 'search_by_address' ) {
		    
		    	if ( $data['address_geocode'] == 'address_google_developers' && !empty( $data['address_google_developers_api_key'] ) ) {
		        
			        $api_key = '&key=' . $data['address_google_developers_api_key'];
			    
			    } elseif ( $data['address_geocode'] == 'address_google_for_work' && !empty( $data['address_google_for_work_client_id'] ) && !empty( $data['address_google_for_work_signature'] ) ) {
			        
			        $api_key = '&client=' . $data['address_google_for_work_client_id'] . '&signature=' . $data['address_google_for_work_signature'];

			    }

		    }

		    // if all fields are updateable and $search has a value
		    if ( empty( $article['ID'] ) or ( $wpresidence_addon->can_update_meta( $field, $import_options ) && $wpresidence_addon->can_update_meta( 'property_latitude', $import_options ) && $wpresidence_addon->can_update_meta( 'property_longitude', $import_options ) && !empty ( $search ) ) ) {
		        
		        // build $request_url for api call
		        $request_url = 'https://maps.googleapis.com/maps/api/geocode/json?' . $search . $api_key;

		        $curl = curl_init();

		        curl_setopt( $curl, CURLOPT_URL, $request_url );

		        curl_setopt( $curl, CURLOPT_RETURNTRANSFER, 1 );

		        $wpresidence_addon->log( '- Getting location data from Geocoding API: ' . $request_url );

		        $json = curl_exec( $curl );

		        curl_close( $curl );
		        
		        // parse api response
		        if ( !empty( $json ) ) {

					$details = json_decode( $json, true );

		            if ( $data['location_settings'] == 'search_by_address' ) {

			            $lat  = $details['results'][0]['geometry']['location']['lat'];

			            $long = $details['results'][0]['geometry']['location']['lng'];

			        } else {

			        	$address = $details['results'][0]['formatted_address'];

			        }

		        }
		        
		    }
		    
		    // update location fields
		    $fields = array(
		        'property_latitude' => $lat,
		        'property_longitude' => $long,
		    );

		    $wpresidence_addon->log( '- Updating latitude and longitude' );
		    
		    foreach ( $fields as $key => $value ) {
		        
		        if ( empty( $article['ID'] ) or $wpresidence_addon->can_update_meta( $key, $import_options ) ) {
		            
		            update_post_meta( $post_id, $key, $value );
		        
		        }
			}
			
			$field = 'property_theme_slider';

			if ( empty ( $article['ID'] ) or $wpresidence_addon->can_update_meta( $field, $import_options ) ) {

				update_option( 'wpresaddon_can_update_slider', '1' );
				
				update_post_meta( $post_id, 'property_theme_slider', $data[ $field ] );

			}

		}

		add_action( 'pmxi_saved_post', 'wpresidence_addon_save_in_slider', 1, 3 );
		if ( function_exists( 'estate_save_postdata' ) ) {
			add_action( 'pmxi_saved_post', 'estate_save_postdata', 1, 1 );
		}
		break;

}

function property_images( $post_id, $attachment_id, $image_filepath, $import_options ) {
	// Get the current list of images
	$current_images = get_post_meta( $post_id, 'image_to_attach', true );

	// Turn it into an array
	$current_images = explode( ",", $current_images );
	
	// Add the new image
	$current_images[] = $attachment_id;

	$current_images = array_filter($current_images);
	
	// image count
	$count = 1;

    // let user know that we are attaching images to given property and that the same image can only be attached to one
   // should probably set it up to use translations later
    $logger = function($m) {printf("<div class='progress-msg'>[%s] $m</div>\n", date("H:i:s"));flush();};
	call_user_func($logger, "<b>Images Attached to this property:</b> Each image can only be attached to one property.  Uncheck 'Search through the Media Library for existing images before importing new images' if you need to import the same image for multiple properties.");

	// ensure images are attached to this post and set the menu order so that they are shown correctly
	foreach($current_images as $image)
	{
		$gallery_post = wp_update_post( array(
   			 'ID'            => $image,
    			'post_parent'   => $post_id,
			'menu_order' => $count,
		), true );

		if( is_wp_error( $gallery_post ) ) {
    			error_log( print_r( $gallery_post, 1 ) );
		}
		
		$count++;
        
  }

	// Turn it back into a string
	$current_images = implode( ",", $current_images );

	// Update the image field while removing any commas before or after the image IDs
	update_post_meta( $post_id, 'image_to_attach', trim( $current_images, "," ) );
}

function wpresidence_addon_get_post_type() {
	/**
	* Show fields based on post type
	**/

	$custom_type = false;

	// Get import ID from URL or set to 'new'
	if ( isset( $_GET['import_id'] ) ) {
		$import_id = $_GET['import_id'];
	} elseif ( isset( $_GET['id'] ) ) {
		$import_id = $_GET['id'];
	}

	if ( empty( $import_id ) ) {
		$import_id = 'new';
	}

	// Declaring $wpdb as global to access database
	global $wpdb;

	// Get values from import data table
	$imports_table = $wpdb->prefix . 'pmxi_imports';

	// Get import session from database based on import ID or 'new'
	$import_options = $wpdb->get_row( $wpdb->prepare("SELECT options FROM $imports_table WHERE id = %d", $import_id), ARRAY_A );

	// If this is an existing import load the custom post type from the array
	if ( ! empty($import_options) )	{
		$import_options_arr = unserialize($import_options['options']);
		$custom_type = $import_options_arr['custom_type'];
	} else {
		// If this is a new import get the custom post type data from the current session
		$import_options = $wpdb->get_row( $wpdb->prepare("SELECT option_name, option_value FROM $wpdb->options WHERE option_name = %s", '_wpallimport_session_' . $import_id . '_'), ARRAY_A );				
		$import_options_arr = empty($import_options) ? array() : unserialize($import_options['option_value']);
		$custom_type = empty($import_options_arr['custom_type']) ? '' : $import_options_arr['custom_type'];		
	}
	return $custom_type;
}

function wpresidence_addon_save_in_slider( $post_id, $xml, $update ) {

	$can_update = get_option( 'wpresaddon_can_update_slider' );

	if ( $can_update == '1' ) {

		$setting = get_post_meta( $post_id, 'property_theme_slider', true );
		
		if ( $setting == '1' ) {

			$current_slider = get_option( 'wp_estate_theme_slider' );

			$current_slider = maybe_unserialize( $current_slider );

			if ( !in_array( $post_id, $current_slider ) ) {

				$current_slider[] = $post_id;

				update_option( 'wp_estate_theme_slider', $current_slider );

			}

		} elseif ( $setting == '0' ) {

			// remove from slider

			$current_slider = get_option( 'wp_estate_theme_slider' );
			
			$current_slider = maybe_unserialize( $current_slider );

			if ( is_array($current_slider) && ( $i = array_search( $post_id, $current_slider ) ) !== false ) {
				
				unset( $current_slider[ $i ] );

			}

			update_option( 'wp_estate_theme_slider', $current_slider );

		}

	}

	delete_option( 'wpresaddon_can_update_slider' );

}

add_action( 'pmxi_saved_post', 'wpresidence_update_hidden_address', 1, 3 );

function wpresidence_update_hidden_address( $post_id, $xml, $update ) {
	
	$is_update = get_post_meta($post_id, 'temp_is_update_hidden_address', true);
	
	if ( empty( $is_update ) ) return;
	
	// Clearing the cache before getting terms, needed later for 'property_county_state' taxonomy
	wp_cache_flush();
	
	// Begin with an empty string
	$hidden_address = '';
	
	// Property address info
	$address = get_post_meta( $post_id, 'property_address', true );
	
	if ( !empty( $address ) ) {
		$hidden_address .= $address . ', ';
	} else {
		$hidden_address .= ', ';
	}

	// Property zip info
	$zip = get_post_meta( $post_id, 'property_zip', true );
	
	if ( !empty( $zip ) ) {
		$hidden_address .= $zip . ', ';
	} else {
		$hidden_address .= ', ';
	}

	// Property neighborhood info
	$neighborhood = get_the_terms( $post_id, 'property_area' );
	
	if ( !empty( $neighborhood ) ) {
		$hidden_address .= $neighborhood[0]->name . ', ';
	} else {
		$hidden_address .= ', ';
	}
	
	// Property city info
	$city = get_the_terms( $post_id, 'property_city' );
	
	if ( !empty( $city ) ) {
		$hidden_address .= $city[0]->name . ', ';
	} else {
		$hidden_address .= ', ';
	}
	
	// Property county/state info
	$county_state = get_the_terms( $post_id, 'property_county_state' );
	
	if ( !empty( $county_state ) ) {
		$hidden_address .= $county_state[0]->name . ', ';
	} else {
		$hidden_address .= ', ';
	}
	
	// Update the 'hidden_address' with the string constructed here
	update_post_meta( $post_id, 'hidden_address', $hidden_address );
	
	// Remove the temporary field we created earlier to note that 'hidden_address' should be updated
	delete_post_meta( $post_id, 'temp_is_update_hidden_address' );

}